﻿/*
 * xplo.re .NET
 *
 * Copyright (C) 2017, xplo.re IT Services, Michael Maier.
 * All rights reserved.
 */

using System;
using System.Linq;
using System.Reflection;
using JetBrains.Annotations;
using XploRe.Runtime.Internal;


namespace XploRe.Reflection
{

    /// <summary>
    ///     Contains extension methods for <see cref="Type" /> instances.
    /// </summary>
    public static class TypeExtensions
    {

#if (NETSTANDARD1_3 || NETSTANDARD1_4 || NETSTANDARD1_5 || NETSTANDARD1_6)

        /// <summary>
        ///     Determines whether the specified type can be assigned to the current type.
        /// </summary>
        /// <remarks>
        ///     This is a polyfill implementation for .NET Standard 1.6 and lower.
        /// </remarks>
        /// <param name="type">This <see cref="Type" /> instance.</param>
        /// <param name="other">The type to check.</param>
        /// <returns><c>true</c> if the specified type can be assigned to this type, otherwise <c>false</c>.</returns>
        [Pure]
        public static bool IsAssignableFrom([NotNull] this Type type, [NotNull] Type other)
        {
            if (type == null) {
                throw new ArgumentNullException(nameof(type));
            }

            if (other == null) {
                throw new ArgumentNullException(nameof(other));
            }

            return type.GetTypeInfo()?.IsAssignableFrom(other) == true;
        }

#endif

        /// <summary>
        ///     Determines whether this type has been generated by the compiler.
        /// </summary>
        /// <param name="type">This <see cref="Type" /> to evaluate.</param>
        /// <returns><c>true</c> if this type is compiler-generated, otherwise <c>false</c>.</returns>
        [Pure]
        public static bool IsCompilerGenerated([NotNull] this Type type)
        {
            if (type == null) {
                throw new ArgumentNullException(nameof(type));
            }

            return TypeHelper.IsCompilerGenerated(type);
        }

        /// <summary>
        ///     Evaluates whether the provided object instance has a <see cref="Type" /> with an interface or a base 
        ///     type that has a generic type definition that is equal to this <see cref="Type" />.
        /// </summary>
        /// <param name="genericType">This generic <see cref="Type" /> to test for.</param>
        /// <param name="instance">
        ///     The object whose <see cref="Type" /> is checked for compatible generic type definitions.
        /// </param>
        /// <returns>
        ///     <c>true</c>, if <paramref name="instance" /> has a type with a generic type definition equal to this 
        ///     <paramref name="genericType" />, otherwise <c>false</c>.
        /// </returns>
        [Pure]
        public static bool IsGenericTypeOfInstance([NotNull] this Type genericType, [CanBeNull] object instance)
        {
            if (genericType == null) {
                throw new ArgumentNullException(nameof(genericType));
            }

            return IsGenericTypeOf(genericType, instance?.GetType());
        }

        /// <summary>
        ///     Evaluates whether the provided <see cref="Type" />, an interface or a base type thereof has a generic 
        ///     type definition that is equal to this <see cref="Type" />.
        /// </summary>
        /// <param name="genericType">This generic <see cref="Type" /> to test for.</param>
        /// <param name="type">The <see cref="Type" /> to check for compatible generic type definitions.</param>
        /// <returns>
        ///     <c>true</c>, if <paramref name="type" /> has a generic type definition equal to this 
        ///     <paramref name="genericType" />, otherwise <c>false</c>.
        /// </returns>
        [Pure]
        public static bool IsGenericTypeOf([NotNull] this Type genericType, [CanBeNull] Type type)
        {
            if (genericType == null) {
                throw new ArgumentNullException(nameof(genericType));
            }

            if (type == null) {
                return false;
            }

            var interfaces = type.GetInterfaces();

            if (interfaces != null &&
                interfaces.Select(@interface => @interface.GetTypeInfo())
                          .Any(
                              typeInfo => typeInfo != null &&
                                          typeInfo.IsGenericType &&
                                          typeInfo.GetGenericTypeDefinition() == genericType)) {
                return true;
            }

            do {
                var typeInfo = type.GetTypeInfo();

                if (typeInfo == null) {
                    break;
                }

                if (typeInfo.IsGenericType &&
                    typeInfo.GetGenericTypeDefinition() == genericType) {
                    return true;
                }

                type = typeInfo.BaseType;
            }
            while (type != null);

            return false;
        }

        /// <summary>
        ///     Tests whether the provided <see cref="Type" /> is equal to or a subclass of this <see cref="Type" />.
        /// </summary>
        /// <param name="type">This <see cref="Type" /> instance.</param>
        /// <param name="otherType">
        ///     The <see cref="Type" /> instance to check for equivalence to this <paramref name="type" /> instance or
        ///     whether it is a subclass thereof.
        /// </param>
        /// <returns>
        ///     <c>true</c>, if <paramref name="otherType" /> is equal to or a subclass of <paramref name="type" />,
        ///     otherwise <c>false</c>.
        /// </returns>
        [Pure]
        public static bool IsSameOrSubclassOf([NotNull] this Type type, [CanBeNull] Type otherType)
        {
            if (type == null) {
                throw new ArgumentNullException(nameof(type));
            }

            return type == otherType || type.GetTypeInfo()?.IsSubclassOf(otherType) == true;
        }

    }

}
